#include "appconfig.h"
#include <sys/types.h>
#include <sys/wait.h>
#include "stdio.h"
#include <QSettings>
#define LIBEXECDIR "/usr/lib/ltools"
#define ROOTFILE "/proc/cmdline"

AppConfig::AppConfig()
{
}


string AppConfig::read_tz(){

    string timezone;
    string words[10];
    ifstream fichier("etc/timezone");
    if(fichier){
        string line;
        while(getline(fichier,line)){
            //str_parse(line,"/",words);
            timezone=words[0];
        }
        return timezone;
    }
    return NULL;
}

void write_tz(QString tz){

    QString cmd ="sh " LIBEXECDIR "/settz.sh " + tz;
    Utils::runCmd(cmd);
}

void AppConfig::get_root_device(QLabel *lbl){

    ifstream fichier(ROOTFILE);
    string line, rootD;
    string words[10];
    while(getline(fichier,line)){

        str_parse(line,'/',words);
        if(words[0] == "root=")
        {
            rootD = words[1];

        }

        // string rootDevice =AppConfig::get_root_device();

        // ui->label_14->setText(QString::fromStdString(rootDevice));

    }
    lbl->setText(QString::fromStdString(rootD));

}

/*
 * get locale from system
 */
string AppConfig::read_locale()
{
#if defined(__arm__) || defined(__x86_64__)
    ifstream fichier("/etc/default/locale");
#else
    ifstream fichier("/etc/environnement");
#endif
    if ( fichier )
    {
        string line;
        while ( getline( fichier, line ) )
        {
            QString qline(line.c_str());
            QStringList qwords = qline.split("=");

            if (qwords.empty()) continue;
            QString key = qwords.at(0);
            key.replace(' ', "");
            if (qwords.size() < 2 || key != "LANG") continue;

            QString qlocale = qwords.at(1);
            qlocale.replace('"', "");

            return qlocale.toStdString();
        }
    }
    return "";
}

/*
 * set system locale
 */
//void
//AppConfig::write_locale (QString locale)
//{
//    QString cmd = "sh " LIBEXECDIR "/setlocale.sh " + locale;
//    Utils::runCmd(cmd, 120000);
//}


/*
 * write config from program parameters
 */
void
AppConfig::writeConfig(bool tzChanged)
{
    //if(languageChanged)
        //write_locale(locale_value);
    if(tzChanged)
        write_tz(tz);

    QSettings settings(LOCKFILE,QSettings::IniFormat);
    if(settings.value("lockEnabled",false).toBool())
    {
#ifdef __arm__
        QProcess process;
        process.start("sh" LIBEXECDIR "/arm_lock_mode.sh " + lockMode);
#endif
#ifdef __x86_64__
        QProcess process;
        process.start("sh" LIBEXECDIR "/amd64_lock_mode.sh " + lockMode);
#endif
    }
}



/* check if the configuration panel autostart is enabled */
void
AppConfig::get_autostart(QCheckBox *chkBox)
{
#ifndef __arm__
        ifstream fichier("/home/linutop/.config/autostart/lconfeditor.desktop");
#else
        ifstream fichier("/home/pi/.config/autostart/lconfeditor.desktop");
#endif
    if ( fichier )
    {
        string line, words[2];
        while ( getline( fichier, line ) )
        {
            str_parse(line,'=',words);
            if(words[0] == "X-GNOME-Autostart-enabled")
            {
                if(words[1] == "false")
                {
                    chkBox->setChecked(false);
                }
            }
        }
    }
}

/* set configuration panel autostart according to the autostart checkbox */
void
AppConfig::set_autostart(QCheckBox *chkBox, bool autostartChanged)
{
    if(autostartChanged)
    {
        QString newFile;
        QFile source("/usr/share/applications/lconfeditor.desktop");
        if(source.open(QFile::ReadOnly |
                      QFile::Text))
        {
            QTextStream in(&source);
            while (!in.atEnd())
           {
              QString line = in.readLine();
              QStringList list = line.split("=");
              if ((list.at(0) != "X-GNOME-Autostart-enabled") &&
                  (list.at(0) != "Hidden"))
              {
                  newFile += line + "\n";
              }
           }

           source.close();

#ifndef __arm__
           QFile file("/home/linutop/.config/autostart/lconfeditor.desktop");
#else
           QFile file("/home/pi/.config/autostart/lconfeditor.desktop");
#endif

           if(chkBox->isChecked())
           {
               newFile += "X-GNOME-Autostart-enabled=true\n";
               newFile += "Hidden=false\n";
           }
           else
           {
               newFile += "X-GNOME-Autostart-enabled=false\n";
               newFile += "Hidden=true\n";
           }

           if(file.open(QFile::WriteOnly | QIODevice::Truncate |
                         QFile::Text))
           {
               QTextStream out(&file);
               out << newFile;
               file.flush();
               file.close();
           }

        }
    }
}

void AppConfig::set_wifi_blue(bool D_wifi, bool D_blue)
{
    QString newFile;
    QFile file("/etc/modprobe.d/raspi-blacklist.conf");
    if(file.open(QFile::ReadWrite |
                  QFile::Text))
    {
        bool keep = true;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "#Linutop configuration")
              keep = false;
          if(keep)
              newFile += line + "\n";
          if(line == "#Linutop end")
              keep = true;
        }
        file.close();

        newFile += "#Linutop configuration\n";
        if(D_wifi)
        {
            newFile += "#wifi\n";
            newFile += "blacklist brcmfmac\n";
            newFile += "blacklist brcmutil\n";
        }
        if(D_blue)
        {
            newFile += "#bluetooth\n";
            newFile += "blacklist btbcm\n";
            newFile += "blacklist hci_uart\n";
        }
        newFile += "#Linutop end\n";

        if(file.open(QFile::WriteOnly | QIODevice::Truncate |
                      QFile::Text))
        {
            QTextStream out(&file);
            out << newFile;
            file.flush();
            file.close();
        }
    }
}
