#include "backup_raspi.h"
#include "ui_backup_raspi.h"
#include <QProcess>
#include <stdio.h>
#include <QtDBus/QDBusAbstractInterface>
#include<fstab.h>
#include <QtDBus/QtDBus>
#include "utils.h"
#include <QDialog>
#include <QPushButton>
#include <QMessageBox>
#include <QThread>
#include <QProgressDialog>
#include <QString>
#include <QGridLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QSpinBox>
#include <QSettings>
#include <QProgressBar>
#define ROOTFILE "/proc/cmdline"
#define DEVICEFILE "/proc/scsi/sg/device_strs"
#ifndef __arm__
#define HOME "/tmp/listMedia"
#define MEDIAINFO "/tmp/infoStorage"
#define LOCALDISK "/tmp/infoLocalDisk"
#else
#define HOME "/tmp/listMedia"
#define MEDIAINFO "/tmp/infoStorage"
#define LOCALDISK "/tmp/infoLocalDisk"
#endif

Backup_raspi::Backup_raspi(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Backup_raspi)
{
    ui->setupUi(this);
    listMedia();
}

void Backup_raspi::listMedia(){
    qDebug()<<"//////////////////Debut initiate Backup_raspi///////////////////////";

    ui->comboBox->clear();
    QProcess process;
    QProcess procRecup_info;

    procRecup_info.setStandardOutputFile(MEDIAINFO);
    process.setStandardOutputFile(HOME);
    process.start("sh", QStringList() << "-c" << "lsblk -l -o KNAME,VENDOR,MODEL,SIZE | grep sd | grep -v mmc");
    process.waitForFinished();

    QFile file(HOME);
    QString retour = NULL;
    QStringList lstAppend;
    if(file.open(QFile::ReadOnly|QFile::Text))
    {
        QString line;
        QTextStream in(&file);
        do{

            line = in.readLine();
        //    qDebug()<<line;
            QStringList lstRes = line.split(" ", QString::SkipEmptyParts);
       //     qDebug()<<"Longueur de lstRes: " << lstRes.length();
            for(int i=0; i<lstRes.length(); i++){
         //       qDebug()<<"\nIteration n°:" << i;

          //        qDebug()<<"\nRecuperation part :" << i;
                    retour = lstRes.at(i);
                    QStringList recupPartition = retour.split("/dev/", QString::SkipEmptyParts);
            //        qDebug()<< "\nrecupPartition:" <<recupPartition;
                    lstAppend.append(recupPartition.at(0));

            }
        }while(!in.atEnd());
    }
    file.close();
     QStringList finalShow;

   // qDebug()<<"listFinale" << lstAppend;


    for(int i=0; i<lstAppend.length(); i++){
        QString correctList = lstAppend.at(i).mid(0, 3);
        procRecup_info.start("sh", QStringList() << "-c" << " lsblk -o KNAME,VENDOR,MODEL,SIZE | grep -v mmc |grep " +correctList );
        procRecup_info.waitForFinished();

        QFile fileInfo(MEDIAINFO);
        QStringList lstResInfo;

        if(fileInfo.open(QFile::ReadOnly)){
            QString lineInfo;
            QTextStream info(&fileInfo);
            do{
                lineInfo = info.readLine();
             //   qDebug()<<"LineInfo" << lineInfo;
                lstResInfo = lineInfo.split(" ", QString::SkipEmptyParts);
             //   qDebug()<<"lstResInfo: " << lstResInfo;
             //   qDebug()<<"Longueur lstResInfo:" << lstResInfo.length();
                if(!(lstResInfo.length()<5)){
                    finalShow.append(lstResInfo.at(1) + " " + lstResInfo.at(2)
                                 + " " + lstResInfo.at(3) + " (" + lstResInfo.at(4) + ") " + "|" + "(" + lstResInfo.at(0) + ")");
                }

            }while(!info.atEnd());
        }
        fileInfo.close();
        for(int i=0; i<finalShow.length();i++){
            for(int j=0; j<finalShow.length();j++){
                if(i!=j){
                    if(finalShow.at(i)==finalShow.at(j)){
          //              qDebug()<<"La ligne " << i << "est identique a la ligne" << j;
                        finalShow.removeAt(j);
                    }
                }
            }
        }
     //   qDebug()<<"Dernier finalShow:"<<finalShow;

    }
        qDebug()<<"////////////////Fin initiate//////////////////////";
    for(int i=0; i<finalShow.length(); i++){
         ui->comboBox->addItem(finalShow.at(i));
    }
}



void Backup_raspi::on_pushB_Refresh_clicked(){
    Backup_raspi::listMedia();
}

void Backup_raspi::on_buttonBox_CancelOkBackup_accepted(){


    qDebug()<<"//////////////Processing backup to device/////////////";
    QMessageBox::StandardButton format_dialog;
    format_dialog = QMessageBox::information(this, " ", "Are you sure you want to backup to that media?", QMessageBox::Yes|QMessageBox::No);
    if(format_dialog == QMessageBox::Yes) {

        QProcess processSplit;
        QProcess processUnmount;
        QProcess processMkfs;
        QProcess processErase;
        QProcess processPartprobe;
        QProcess processCreate;
        QProcess processBackupArm;
        QThreadBackup *BackupThread = new QThreadBackup();

        progress_dialog = new QProgressDialog();


       connect(&processUnmount,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
       connect(&processPartprobe,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
       connect(&processMkfs,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
       connect(&processErase,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
       connect(&processCreate,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
       connect(&processSplit,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(reset()));

//        qDebug()<<"\n/////////////Getting the line///////////////";
        if(!ui->comboBox->currentText().isEmpty()){
            QStringList lstLineComboBox=ui->comboBox->currentText().split("|").last().split("(", QString::SkipEmptyParts).last().split(")",QString::SkipEmptyParts);
//            qDebug()<<"Ligne recuperee:"<<lstLineComboBox;
            QString retour = lstLineComboBox.at(0);
            QString tmp = "/dev/"+retour;
            retour=tmp;

#ifdef __arm__

            QProcess taille_disk;
            taille_disk.start("sh", QStringList()<<"-c"<<"df -h | grep /dev/root | awk ' { print $3 } ' | grep -v fichiers");
            taille_disk.waitForFinished();
#else

            QProcess taille_disk;
            taille_disk.start("sh", QStringList()<<"-c"<<"df -h /dev/mmcblk0p2 | awk ' { print $3 } ' | grep -v fichiers");
            taille_disk.waitForFinished();

#endif
            QString output_taille_disk = taille_disk.readAllStandardOutput();
            QStringList taille_disk_list = output_taille_disk.split("G", QString::SkipEmptyParts);
            QString taille_disk_virgule = taille_disk_list.at(0);
            taille_disk_virgule.replace(",",".");
            float taille_disk_util = taille_disk_virgule.toFloat();
            qDebug()<<"Size of Disk :"<<taille_disk_util<<endl;


            QProcess taille_usb;
            taille_usb.start("sh", QStringList()<<"-c"<<"lsblk "+retour+" | grep disk | awk ' { print $4 } '");
            taille_usb.waitForFinished();

            QString output_taille_usb = taille_usb.readAllStandardOutput();
            QStringList taille_usb_list = output_taille_usb.split("G", QString::SkipEmptyParts);
            QString taille_usb_virgule = taille_usb_list.at(0);
            taille_usb_virgule.replace(",",".");
            float taille_usb_util=taille_usb_virgule.toFloat();
            qDebug()<<"Size of Usb :"<<taille_usb_util<<endl;

            if (taille_disk_util > taille_usb_util)
            {
                QMessageBox::StandardButton format_dialogEmpty;
                format_dialogEmpty = QMessageBox::information(this, " ", "ERROR: Taille Usb Insuffisante ... ", QMessageBox::Cancel);
            }


            else
            {

            QProcess partition;
            partition.start("sh", QStringList() << "-c" << "lsblk " + retour + " | grep -v disk | grep -v NAME | wc -l" );
            partition.waitForFinished();

            QString output = partition.readAllStandardOutput();
            qDebug()<<"Read output:"<<output;
            QString nbPartition = output.left(1);
            int k = nbPartition.toInt();
            QString listNum[10]={"1","2","3","4","5","6","7","8","9"};
            qDebug()<<"Number of partitions :"<< k;

            qDebug()<<"Suppressing all partition in the device";

                    for (int j=0; j<k ;j++){

                        qDebug()<<"Check error:";
                        processPartprobe.start("sh", QStringList() << "-c" << " sudo partprobe " + retour);
                        ui_thread();
                        processPartprobe.waitForFinished();

                        qDebug()<<"Partition: "<<listNum[j];
                        qDebug()<<"echo -e 'd\n" + listNum[j] +"' | sudo fdisk " + retour;

                        qDebug()<< "Trying to erase...";
                        processErase.start("sh", QStringList() << "-c" << " sudo echo -e 'd\n" + listNum[j] + "\nw' | sudo fdisk " + retour);
                        ui_thread();
                        processErase.waitForFinished();
                        qDebug()<< "Device erased.";

                        qDebug()<<"Trying to umount...";
                        processUnmount.start("sh", QStringList() << "-c" << " umount " + retour + listNum[j]);
                        ui_thread();
                        processUnmount.waitForFinished();
                        qDebug()<< "Media Unmounted";
                }



                    processPartprobe.start("sh", QStringList() << "-c" << " sudo partprobe " + retour);
                    ui_thread();
                    processPartprobe.waitForFinished();





                    //connect(progress_dialog,SIGNAL(finished()),BackupThread,SLOT(close()));
                    connect(BackupThread,SIGNAL(finished()),progress_dialog,SLOT(close()));


#ifdef __arm__





                   connect(&processBackupArm,SIGNAL(finished(int,QProcess::ExitStatus)),progress_dialog,SLOT(close()));
                   qDebug()<<"lancement du DD";
                   processBackupArm.start("sh", QStringList() <<"-c" << "dd if=/dev/mmcblk0 of=" + retour);
                   ui_thread();
                   processBackupArm.waitForFinished();

#else
             BackupThread->start();
             qDebug()<<"Lancement du THREAD: "<<endl;
             ui_thread();
             qDebug()<<"Fin du Thread.";
             QMessageBox::StandardButton format_dialogEmpty;
             format_dialogEmpty = QMessageBox::information(this, " ", "Backup Fini !", QMessageBox::Ok);
#endif

        }}else{
            QMessageBox::StandardButton format_dialogEmpty;
            format_dialogEmpty = QMessageBox::information(this, " ", "ERROR:You didn't select any media.", QMessageBox::Cancel);
        }


    }else if(format_dialog == QMessageBox::No) {
        Backup_raspi *d = new Backup_raspi();
        d->exec();
    }
}


void Backup_raspi::ui_thread ()
{
    progress_dialog->setWindowTitle("Applying configuration");
    progress_dialog->setLabelText("Please wait while executing the request...");
    progress_dialog->setRange(0,0);
    progress_dialog->exec();

}




Backup_raspi::~Backup_raspi()
{
    delete ui;
}
