#include "dadv_overscan.h"
#include "ui_dadv_overscan.h"
#include "screenconfig.h"
#include <QFile>
#include <QTextStream>
#include <QDebug>
#include <mainwindow.h>

dadv_overscan::dadv_overscan(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::dadv_overscan)
{
    ui->setupUi(this);
    ui->LB_ex_cust_overscan->setPixmap(QPixmap(LIBEXECDIR "/ex_overscan.png"));
    setWindowTitle(tr("Advanced display configuration"));
    on_CHK_cust_overscan_toggled(false);
    read_config();
}

dadv_overscan::~dadv_overscan()
{
    delete ui;
}
#include <unistd.h>
void dadv_overscan::read_config()
{
    QFile file(PICONFFILE);
    if(file.open(QFile::ReadOnly |
                  QFile::Text))
    {
        QTextStream in(&file);
        while (!in.atEnd())
        {
            QString line = in.readLine();

            QStringList cvt_param = line.split(" ");
            if (cvt_param.at(0) == "hdmi_cvt")
            {
                ui->LE_width->setText(cvt_param.at(1));
                ui->LE_height->setText(cvt_param.at(2));
                ui->LE_fps->setText(cvt_param.at(3));
                ui->CHK_customRes->setChecked(true);
            }

            QStringList list = line.split("=");
            if((list.at(0) == "overscan_left"))
                ui->LE_ov_left->setText(list.at(1));
            if((list.at(0) == "overscan_right"))
                ui->LE_ov_right->setText(list.at(1));
            if((list.at(0) == "overscan_top"))
                ui->LE_ov_top->setText(list.at(1));
            if((list.at(0) == "overscan_bottom"))
                ui->LE_ov_bot->setText(list.at(1));
            if((list.at(0) == "#scale_width"))
                ui->LE_scale_width->setText(list.at(1));
            if((list.at(0) == "#scale_height"))
                ui->LE_scale_height->setText(list.at(1));

            if((list.at(0) == "disable_overscan") && (list.at(1) == "1"))
                ui->chkOverscan->setChecked(true);
            if (list.at(0) == "hdmi_mode" && list.at(1) == "87")
                ui->chkOverscan->setChecked(true);
            if (list.at(0) == "#cust_overscan" && list.at(1) == "1")
            {
                ui->CHK_cust_overscan->setChecked(true);
                on_CHK_cust_overscan_toggled(true);
            }
        }
        file.close();
    }
    if (((ScreenConfig*)parentWidget())->choosed_res != "0")
        ui->LBL_base_res->setText(((ScreenConfig*)parentWidget())->choosed_res);
}



void dadv_overscan::on_buttonBox_accepted()
{
    QString newFile;

    if (QFile::exists(SAVECONF))
    {
        QFile::remove(SAVECONF);
    }
    QFile::copy(PICONFFILE, SAVECONF);

    QFile file(PICONFFILE);
    if(file.open(QFile::ReadWrite |
                  QFile::Text))
    {
        bool keep = true;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "#Linutop overscan configuration")
              keep = false;
          if(keep)
              newFile += line + "\n";
          if(line == "#Linutop overscan end")
              keep = true;
        }
        file.close();
        newFile += "#Linutop overscan configuration\n";

        if(ui->chkOverscan->isChecked())
        {
            newFile += "disable_overscan=1\n";
            ui->LE_ov_left->setText("");
            ui->LE_ov_right->setText("");
            ui->LE_ov_top->setText("");
            ui->LE_ov_bot->setText("");
        }

        if (ui->CHK_customRes->isChecked()
                && !(ui->LE_width->text().isEmpty()) && !(ui->LE_height->text().isEmpty()) && !(ui->LE_fps->text().isEmpty()))
        {
            newFile += "hdmi_ignore_edid=0xa5000080\n";
            newFile += "hdmi_group=2\n";
            newFile += "hdmi_mode=87\n";
            newFile += "hdmi_cvt " + ui->LE_width->text() + " " + ui->LE_height->text() + " " + ui->LE_fps->text();
            newFile += "\n";
            custom_res = true;
        }
        else
            custom_res = false;

        if (ui->CHK_cust_overscan->isChecked())
        {
            newFile += "#cust_overscan=1\n";
            newFile += "overscan_left=0\n";
            newFile += "overscan_top=0\n";
            int width = ui->LE_scale_width->text().toInt();
            int height = ui->LE_scale_height->text().toInt();

            QStringList ori_res = ui->LBL_base_res->text().split("x");
            newFile += "overscan_right=" + QString::number(ori_res.at(0).toInt() - width) + "\n";
            newFile += "overscan_bottom=" + QString::number(ori_res.at(1).toInt() - height) + "\n";

        }
        else
        {
            if (!ui->LE_ov_left->text().isEmpty())
                newFile += "overscan_left=" + ui->LE_ov_left->text() + "\n";
            if (!ui->LE_ov_right->text().isEmpty())
                newFile += "overscan_right=" + ui->LE_ov_right->text() + "\n";
            if (!ui->LE_ov_top->text().isEmpty())
                newFile += "overscan_top=" + ui->LE_ov_top->text() + "\n";
            if (!ui->LE_ov_bot->text().isEmpty())
                newFile += "overscan_bottom=" + ui->LE_ov_bot->text() + "\n";
        }
        if (!ui->LE_scale_width->text().isEmpty())
            newFile += "#scale_width=" + ui->LE_scale_width->text() + "\n";
        if (!ui->LE_scale_height->text().isEmpty())
            newFile += "#scale_height=" + ui->LE_scale_height->text() + "\n";
        newFile += "#Linutop overscan end\n";

        if(file.open(QFile::WriteOnly | QIODevice::Truncate |
                      QFile::Text))
        {
            QTextStream out(&file);
            out << newFile;
            file.flush();
            file.close();
        }

        close();
    }
}

void dadv_overscan::on_CHK_cust_overscan_toggled(bool checked)
{
    ui->LE_scale_height->setEnabled(checked);
    ui->LE_scale_width->setEnabled(checked);
    ui->label_8->setEnabled(checked);
    ui->label_9->setEnabled(checked);
    ui->label_13->setEnabled(checked);
    ui->LBL_base_res->setEnabled(checked);
    ui->label_10->setEnabled(checked);
    ui->label_16->setEnabled(checked);
    ui->LB_ex_cust_overscan->setEnabled(checked);
}
