#include "dialog.h"
#include "ui_dialog.h"
#define LIBEXECDIR "/usr/lib/ltools"
#include "utils.h"
#include "mainwindow.h"
#include <time.h>
#include <QFile>
#include <QDir>
#include <QTreeWidgetItem>
#define ZONEINFO "/usr/share/zoneinfo/posix"




Dialog::Dialog(QWidget *parent) :
    QDialog(parent),


    ui(new Ui::Dialog)
{

    ui->setupUi(this);

}


Dialog::~Dialog()
{
    delete ui;
}

void Dialog::populate_tz_tree(QPushButton *btn)
{
    QDir dir(ZONEINFO);
    QFileInfoList cont = dir.entryInfoList(QDir::AllDirs |QDir::NoDotAndDotDot ,QDir::Name);

    foreach(QFileInfo fileInfo, cont)
    {
        QTreeWidgetItem *item=new QTreeWidgetItem();
        item->setText(0,fileInfo.fileName());

        if(fileInfo.fileName().contains("."))
        {
            fileInfo.dir().remove(fileInfo.fileName());
        }

        if(fileInfo.isDir())
        {
            ui->listW_continent->addTopLevelItem(item);
            if(item->text(0) == btn->text().split("/")[0])
            {
                continent = item->text(0);
                ui->listW_continent->setCurrentItem(item);
                ui->listW_continent->scrollToItem(item,QAbstractItemView::PositionAtCenter);
                QString tmp = ZONEINFO "/" + item->text(0);
                QDir* rootDir = new QDir(tmp);
                QFileInfoList filesList = rootDir->entryInfoList(QDir::AllEntries |QDir::NoDotAndDotDot);

                foreach(QFileInfo fileInfo, filesList)
                {
                    QTreeWidgetItem* child = new QTreeWidgetItem();
                    child->setText(0,fileInfo.fileName());


                    if(fileInfo.isFile())
                    {
                      child->setText(1,QString::number(fileInfo.size()));
                    }

                    if(fileInfo.isDir())
                    {

                      child->setText(2,fileInfo.filePath());
                    }

                    ui->listW_city->addTopLevelItem(child);

                    if(child->text(0) == btn->text().split("/")[1])
                    {
                        ui->listW_city->setCurrentItem(child);
                        ui->listW_city->scrollToItem(child,QAbstractItemView::PositionAtCenter);
                    }
                }
            }
        }
    }
}

void Dialog::on_buttonBox_accepted()
{
    QString zone = continent + "/" + ui->listW_city->currentItem()->text(0);
    emit signalUpdateBtn(zone);
    close();
}



void Dialog::on_buttonBox_rejected()
{
    close();
}

void Dialog::on_listW_continent_itemClicked(QTreeWidgetItem *item, int column)
{
    ui->listW_city->clear();
    QString tmp = ZONEINFO "/" + item->text(column);
    QDir* rootDir = new QDir(tmp);
    QFileInfoList filesList = rootDir->entryInfoList(QDir::AllEntries |QDir::NoDotAndDotDot);

    foreach(QFileInfo fileInfo, filesList)
    {
        QTreeWidgetItem* child = new QTreeWidgetItem();
        child->setText(0,fileInfo.fileName());


        if(fileInfo.isFile())
        {
          child->setText(1,QString::number(fileInfo.size()));
        }

        if(fileInfo.isDir())
        {

          child->setText(2,fileInfo.filePath());
        }

        ui->listW_city->addTopLevelItem(child);
    }
    continent = item->text(column);
    ui->listW_city->setCurrentItem(ui->listW_city->itemAt(0,0));
}
