#ifndef DLANGUAGE_H
#define DLANGUAGE_H

#include <QDialog>
#include <QProgressDialog>
#include "ui_dlanguage.h"
#include <QThread>
#include <QMessageBox>
#include "appconfig.h"
#include "utils.h"

namespace Ui {
class DLanguage;
}

class DLanguage : public QDialog
{
    Q_OBJECT

public:
    explicit DLanguage(QWidget *parent = 0);
    ~DLanguage();
    void populate_locale_tree(QPushButton *btnL);

private:
    Ui::DLanguage *ui;
    volatile int done;
    QProgressDialog *progress_dialog;
    void ui_thread();
    void ui_language_thread();
    void maybe_install_pkgs (QString pkgs, QString language);

private slots:
    void on_buttonBox_accepted();
    void installCancelled();

signals:
    void signalUpdateBtn(QString language,bool cancel);
};


class QThreadInstall : public QThread
{
public:
    QString data;
    void run() {
        QProcess *install = new QProcess();

        install->start("sudo apt-get update");
        install->waitForStarted();
        install->waitForFinished(-1);

        install->start("sudo apt-get install -y --force-yes " + data);
        install->waitForStarted();
        install->waitForFinished(-1);
    }
};
#endif // DLANGUAGE_H
