#include "dlock.h"
#include "ui_dlock.h"
#include "utils.h"
#include "mainwindow.h"
#include <QSettings>
#include <QDir>

DLock::DLock(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DLock)
{
    ui->setupUi(this);

    //masque le mot de passe
    ui->lineEdit->setEchoMode(QLineEdit::Password);
    ui->lineEdit_2->setEchoMode(QLineEdit::Password);

    QSettings *settings = new QSettings(LOCKFILE,QSettings::IniFormat);
    QString motDePasse = settings->value("Password").toString();
    ui->lineEdit->setText(motDePasse);
    ui->lineEdit_2->setText(motDePasse);

}

DLock::~DLock()
{
    delete ui;
}

void DLock::on_lineEdit_2_returnPressed()
{
    on_pushB_ok_clicked();
}


void DLock::on_pushB_ok_clicked()
{
    if(ui->lineEdit->text() == ui->lineEdit_2->text() && ui->lineEdit->text() != "")
        accept();
    else
    {
        ui->lineEdit->clear();
        ui->lineEdit_2->clear();
        QMessageBox::warning(this,tr("Invalid password"),tr("<FONT COLOR='#800000'>Your password is invalid.</FONT> <br/>Please checkout and re-enter password."));
    }
}

void DLock::on_lineEdit_returnPressed()
{
    on_pushB_ok_clicked();
}

void DLock::on_pushB_cancel_clicked()
{
    reject();
}

void DLock::accept()
{
    QSettings *settings= new QSettings(LOCKFILE,QSettings::IniFormat);
    settings->setValue("Password",ui->lineEdit->text());
    password = ui->lineEdit->text();
    QDialog::accept();
}
