/**
* This class mean to get the previous proxy settings from the file /etc/environment
*
**/


#include "dproxy.h"
#include "ui_dproxy.h"
#include <QNetworkProxy>
#include <QNetworkProxyFactory>
#include <QString>
#include <QGridLayout>
#include <QGroupBox>
#include <QRadioButton>
#include <QSpinBox>
#include <QSettings>
#include <qtcpserver.h>
#include <QList>
#include <QNetworkAccessManager>
#include <QFile>
#include <QUrl>
#include "natproxy.h"
#include <unistd.h>
#include <stdio.h>
#include <QDebug>
#include <QProcess>





int Dproxy::recup_mode=1;
QString Dproxy::recup_host="http://my.proxy.url:port";
QString Dproxy::recup_passwd="";
QString Dproxy::recup_user="";
QString Dproxy::recup_type="http";
QString Dproxy::recup_proxy="";



Dproxy::Dproxy(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dproxy)
{
    /**
     * @brief filemode
     * This file should contains the mode of the proxy (manual, auto or none)
     * in order to maintain it at each session and each opening of the
     * configuration panel
     */
    // qDebug()<<"/////////////////Opening proxy mode////////////////////////";
    QFile filemode("/tmp/choixmodeproxy");
    if(filemode.open(QIODevice::ReadOnly| QIODevice::Text)){
        QTextStream choix(&filemode);
        int tmp = choix.readAll().toInt();
        Dproxy::recup_mode=tmp;
//        qDebug()<<"Selected mode:" << Dproxy::recup_mode
//                << "\n@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@";

    }

    ui->setupUi(this);


    /////////////////////////////////////////////////////////////////////////
    /**
     * @brief fileproxy
     * This file should contains environment variables of the proxy configuration
     */
    QFile fileproxy("/etc/environment");
    QString line[100];
    int line_count=0;
    if(fileproxy.open(QIODevice::ReadOnly | QIODevice::Text)){
//        qDebug()<<"First file opening"
//               << "\n/////////////////////////////////////";

        /***
         * This loop verify if the file is empty or not
         ***/
        QTextStream lineexport(&fileproxy);
        while(!lineexport.atEnd()){
            QString a =lineexport.readLine();
            if(fileproxy.pos() == 0){
                /////
                /// If the file is empty, write export http_proxy=http://my.proxy.url:port
                /// and http://my.proxy.url:port in the ui
                /////
//                qDebug()<<"Empty file";
                ui->line_url->setText("http://my.proxy.url:port");

            }
            fileproxy.close();

        }
    }
    if(fileproxy.open(QIODevice::ReadWrite | QIODevice::Append)){
//        qDebug()<<"#############################" << "\nSecond file opening"
//               <<"\n///////////////////////////////////////";
        QTextStream lineexport(&fileproxy);
        int manyrow=0;
        QString a;
        lineexport.seek(0);
        while(!lineexport.atEnd()){
//            qDebug()<<"Line counting.";
            a = lineexport.readLine();
            manyrow++;
        }
//        qDebug()<<"How many row?:" <<manyrow;
        if(manyrow<3){
            lineexport << "export http_proxy=";
        }
        lineexport.seek(0);
        while(!lineexport.atEnd()){
            ////
            /// If the file is not empty then, get the line of the configuration
            /// and parse it to keep the url part.Then set it to the ui
            ////

//            qDebug()<<"\n////////////////////////////////" << "\nLines contents:";
            line[line_count]=lineexport.readLine();
//            qDebug()<<"The line " << line_count << " contains:" << line[line_count];
            QString tmpproxy;
                if(line_count==2){
                    if(line[line_count].contains("export")){
                        tmpproxy=line[line_count];
                    }
                }


                ////
                /// If the file has been written correctly
                ////
                if(tmpproxy.contains("export http_proxy=")){
//                    qDebug()<<"Enter export line.";
                    ////
                    /// If the proxy contains a user and a password
                    ////

                    if(tmpproxy.contains("@")){
//                        qDebug()<<"Line includes @.";
                        QStringList tmpList = tmpproxy.split("//").last().split(":");
                        QStringList tmpList2;
                        QStringList tmpList3;
                        if(!tmpList.isEmpty()){
//                            qDebug()<<"Get username:"<<tmpList.at(0);
                            Dproxy::recup_user=tmpList.at(0);
                        }
                        tmpList2 = tmpproxy.split("@").first().split(":");
                        if(!tmpList2.isEmpty()){
//                            qDebug()<<"Get password:"<<tmpList2.at(2);
                            Dproxy::recup_passwd=tmpList2.at(2);

                        }
                        tmpList3 = tmpproxy.split(Dproxy::recup_user).last()
                                .split(Dproxy::recup_passwd);
                        if(!tmpList3.isEmpty()){
//                            qDebug()<<"///////////////////////////\n"
//                                   << "Get url";
                            Dproxy::recup_proxy=tmpList3.at(1);
                            tmpproxy= "http://"+tmpList3.at(1);
                        }

                        tmpproxy.remove("@");
                        Dproxy::recup_host=tmpproxy;


                    }else if(tmpproxy.contains("export http_proxy=http://my.proxy.url:port")){
                        ////
                        /// If the proxy is already set by default
                        /// and wrote incorrectly in the file
                        ////
//                        qDebug()<< "Default url line: probleme d'ecriture\n";

                    }else{
                        ////
                        /// If the proxy not contain any username or password
                        ////
//                        qDebug()<<"tmpproxy value:" << tmpproxy;
                        QStringList tmpList = tmpproxy.split("=");
//                        qDebug()<<"tmpList value" << tmpList;

                        ////
                        /// If the proxy line is empty (first time using or deleted)
                        ////
                        if(tmpList.at(1).isEmpty()){
                            tmpproxy="http://my.proxy.url:port";
//                            qDebug()<<"Empty list";

                        }else{
                            Dproxy::recup_host=tmpList.at(0)+tmpList.at(1);
                            Dproxy::recup_proxy=tmpList.at(0)+tmpList.at(1);
                            //tmpproxy= "http://"+tmpList.at(0)+tmpList.at(1);
                            tmpproxy.remove("export http_proxy=");
                            Dproxy::recup_host=tmpproxy;
//                            qDebug()<<"tmpproxy value:" << tmpproxy;
                            ui->line_url->setText(tmpproxy);

                        }
                        break;
                    }
                   ui->line_url->setText(tmpproxy);
                }else{
//                    qDebug()<<"Wrong line so did't get it";
                }


//                qDebug()<<"Get url after processing:" << tmpproxy;
                line_count++;
            }
//        qDebug()<<"ui host:" << ui->line_url->text();
//        qDebug()<<"Initiate end" << "\nOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO";
        fileproxy.close();
    }
    /***
     * Settings the ui accordingly after previous treatments
     */

    ui->proxyAuto->setText(tr("Detection automatique des parametres de proxy"));
    ui->proxyManu->setText(tr("Configuration manuelle du proxy"));
    ui->proxyNone->setText(tr("Pas de proxy"));

    if (Dproxy::recup_mode==3){
        ui->proxyAuto->click();
        disableItem(true);
    }else if(Dproxy::recup_mode==2){
        ui->proxyManu->click();
        ableItem(true);
    }else if(Dproxy::recup_mode==1){
        ui->proxyNone->click();
        disableItem(true);
    }

    ui->lbl_URL->setText(tr("Proxy URL : "));
    ui->line_user->setText(Dproxy::recup_user);
    ui->line_passwd->setText(Dproxy::recup_passwd);

    ui->lbl_user->setText(tr("User : "));
    ui->lbl_passwd->setText(tr("Password : "));


    ui->validProxy->setText(tr("Valid"));
    ui->quitProxy->setText(tr("Quit"));
    connect(ui->proxyAuto,SIGNAL(clicked(bool)),this,SLOT(disableItem(bool)));
    connect(ui->proxyNone,SIGNAL(clicked(bool)),this,SLOT(disableItem(bool)));
    connect(ui->proxyManu,SIGNAL(clicked(bool)),this,SLOT(ableItem(bool)));
    connect(ui->quitProxy,SIGNAL(clicked()),this,SLOT(reject()));
    connect(ui->validProxy,SIGNAL(clicked()),this,SLOT(accept()));
}

Dproxy::~Dproxy()
{
    delete ui;
}




void Dproxy::disableItem(bool a)
{
    if (a == true)

    {
        ui->line_url->setDisabled(true);
        ui->line_user->setDisabled(true);
        ui->line_passwd->setDisabled(true);
    }

}

void Dproxy::ableItem(bool a){

    if(a == true)

    {

        ui->line_url->setDisabled(false);
        ui->line_user->setDisabled(false);
        ui->line_passwd->setDisabled(false);

    }

}

void Dproxy::accept(void)
{
    qDebug()<<"////////////////////Enter proxy validation process /////////////////";
    QFile fileproxy("/etc/environment");
    QFile filemode("/tmp/choixmodeproxy");
    QTextStream mode(&filemode);
    if(ui->proxyNone->isChecked()){
        if(filemode.open(QIODevice::WriteOnly | QIODevice::Truncate)){
            mode << "1";
        }
        filemode.close();
        QNetworkProxyFactory::setUseSystemConfiguration(false);
        QString line[100];
        QTextStream lineexport(&fileproxy);
        int line_count=0;
        QString tmpproxy;
        QStringList splitForSpecLine;
        if(fileproxy.open(QIODevice::ReadOnly | QIODevice::Text))
        {
            ////
            /// This loop should copy all the proxy to a QStringList
            ////
            fileproxy.seek(0);
            while(!lineexport.atEnd()){
                line[line_count]=lineexport.readLine();
                splitForSpecLine.append(line[line_count]);
                if(line_count==2){
                    if(line[line_count].contains("export")){


                    }
                }
                line_count++;
            }
            fileproxy.close();
        }
        ////
        /// To emptied the file
        ////
        if(fileproxy.open(QIODevice::WriteOnly | QIODevice::Truncate)){
            lineexport << "";
            fileproxy.close();
        }
        if(fileproxy.open(QIODevice::WriteOnly | QIODevice::Append)){

            ////
            /// \brief finalsplit
            /// finalsplit is the final stringlist tha will be added to the file
            /// in order to remplace the third line by the new one
            ////
            QStringList finalsplit;

//            qDebug()<<"Writting file";
            tmpproxy=ui->line_url->text();
            finalsplit=splitForSpecLine;
            for(int i=0; i<splitForSpecLine.size(); i++){
                QString veryverytmp;
                veryverytmp = "export http_proxy=";
                finalsplit.replace(2, veryverytmp);
//                qDebug()<<"Final line:" << finalsplit;
                lineexport << finalsplit.at(i) << "\n";
            }
            fileproxy.close();
        }
        QNetworkProxy::setApplicationProxy(QNetworkProxy::NoProxy);
    }
    else if(ui->proxyAuto->isChecked()){
        if(filemode.open(QIODevice::WriteOnly | QIODevice::Truncate)){
            mode << "3";
        }
        filemode.close();
        QNetworkProxyFactory::setUseSystemConfiguration(true);
    }
    else if(ui->proxyManu->isChecked()){
        if(filemode.open(QIODevice::WriteOnly | QIODevice::Truncate)){
            mode << "2";
        }
        filemode.close();
        QNetworkProxyFactory::setUseSystemConfiguration(false);


        QString hostname=ui->line_url->text();
        Dproxy::recup_host=hostname;
        QString string_type = QString(hostname).replace(
                    QRegExp("^([^:]*)://.*$"), "\\1");
        if (string_type == "http"){
            Dproxy::recup_type=string_type;
        }else if(string_type == "ftp"){
            Dproxy::recup_type=string_type;
        }else if(string_type == "https"){
            Dproxy::recup_type=string_type;
        }

        Dproxy::recup_passwd=ui->line_passwd->text();
        Dproxy::recup_user=ui->line_user->text();

        NatProxy* factory = new NatProxy(2, Dproxy::recup_host, Dproxy::recup_user,
                                         Dproxy::recup_passwd);
        QNetworkProxyFactory::setApplicationProxyFactory((factory));

        int indice;
        QStringList splittmpproxy;
        QString line[100];
        QTextStream lineexport(&fileproxy);
        int line_count=0;
        QString tmpproxy;
        QStringList splitForSpecLine;
        if(fileproxy.open(QIODevice::ReadOnly | QIODevice::Text))
        {
            ////
            /// This loop should copy all the proxy to a QStringList
            ////
            fileproxy.seek(0);
            while(!lineexport.atEnd()){
                line[line_count]=lineexport.readLine();
                splitForSpecLine.append(line[line_count]);
                if(line_count==2){
                    if(line[line_count].contains("export")){


                    }
                }
                line_count++;
            }
            fileproxy.close();
        }
        ////
        /// To emptied the file
        ////
        if(fileproxy.open(QIODevice::WriteOnly | QIODevice::Truncate)){
            lineexport << "";
            fileproxy.close();
        }
        if(fileproxy.open(QIODevice::WriteOnly | QIODevice::Append)){

            ////
            /// \brief finalsplit
            /// finalsplit is the final stringlist tha will be added to the file
            /// in order to remplace the third line by the new one
            ////
            QStringList finalsplit;

//            qDebug()<<"Writting file";
            tmpproxy=ui->line_url->text();
            finalsplit=splitForSpecLine;
            for(int i=0; i<splitForSpecLine.size(); i++){
                QString veryverytmp;
                if(tmpproxy.contains("http://my.proxy.url:port")){
                    veryverytmp = "export http_proxy=";
                    recup_user.clear();
                    recup_passwd.clear();
                }else if(recup_user.isEmpty() || recup_passwd.isEmpty()){
//                    qDebug()<<"At least one argument is missing";
                    veryverytmp = "export http_proxy=" + tmpproxy;
//                    qDebug()<<"veryverytmp" << veryverytmp;
                }else{
                    splittmpproxy = tmpproxy.split("//");
//                    qDebug()<<"There is an username and a password";
                    if(splitForSpecLine.at(i).contains("export http_proxy=")){
                        indice = i;
                        veryverytmp="export http_proxy=" + splittmpproxy.at(0)+"//"
                                +recup_user+":"+recup_passwd+"@" + splittmpproxy.at(1);
                    }
                }
                finalsplit.replace(2, veryverytmp);
//                qDebug()<<"Final line:" << finalsplit;
                lineexport << finalsplit.at(i) << "\n";
            }
            fileproxy.close();
        }
    }
    QDialog::accept();
}

void Dproxy::on_proxyNone_clicked()
{
    Dproxy::recup_mode=1;
    QNetworkProxyFactory::setUseSystemConfiguration (false);
    QNetworkProxy::setApplicationProxy(QNetworkProxy::NoProxy);
}

void Dproxy::on_proxyAuto_clicked()
{
    Dproxy::recup_mode=3;
    QNetworkProxyQuery pQuery(QUrl(QLatin1String("http://www.google.com")));
    QList<QNetworkProxy>listOfProxies =QNetworkProxyFactory::systemProxyForQuery(pQuery);
    QNetworkProxy::setApplicationProxy(listOfProxies.first());

}



void Dproxy::on_proxyManu_clicked()
{
    Dproxy::recup_mode=2;

}
