#include "dsharewindows.h"
#include "ui_dsharewindows.h"
#include <QFile>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <QProcess>
#include "utils.h"
#include <QSettings>


#define SMBCONFFILE "/etc/linutopd/onboot/smbmountss.conf"
#define SMBCMD "/usr/lib/linutopd/onboot/01smbmounts"


DshareWindows::DshareWindows(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DshareWindows)
{
    ui->setupUi(this);
    ui->lbl_host->setText(tr("See Windows network properties"));
    ui->lbl_dir->setText(tr("Any Windows shared directory"));
    ui->lbl_mpoint->setText(tr("Access directory on Linutop"));
    ui->lbl_user->setText(tr("User owning the share (optional)"));
    ui->lbl_passwd->setText(tr("Password to access the share (optional)"));

      QFont font("Arial",8);
      ui->lbl_host->setFont(font);
      ui->lbl_dir->setFont(font);
      ui->lbl_mpoint->setFont(font);
      ui->lbl_user->setFont(font);
      ui->lbl_passwd->setFont(font);

      mount_read();





}

DshareWindows::~DshareWindows()
{
    delete ui;
}

void DshareWindows::mount_free(){



}

void DshareWindows::get_mount_from_form (){

    m.host = ui->line_host->text();
    m.dir = ui->line_dir->text();
    m.mpoint = ui->line_mpoint->text();
    m.passwd =ui->line_passwd->text();
    m.user = ui->line_user->text();

}

void append_mount_to_tree(mount *m){

}

//add button slot
void DshareWindows::on_pushB_add_clicked()
{

  QTreeWidgetItem *access = new QTreeWidgetItem();


  access->setText(0,ui->line_host->text());
  access->setText(1,ui->line_dir->text());
  access->setText(2,ui->line_mpoint->text());
  access->setText(3,ui->line_user->text());
  ui->treeWidget->addTopLevelItem(access);
  mount_save();
}

//delete item selected
void DshareWindows::Suppr()
{
   QTreeWidgetItem *i=ui->treeWidget->currentItem();
   if (i)
       delete i;
}

//mount save configuration
void DshareWindows::mount_save(){

        QFile file(SMBCONFFILE);
        if(file.open(QFile::ReadWrite|QFile::Text)){

            QTextStream out(&file);
            out << "host=" << m.host <<endl;
            out << "dir=" << m.dir <<endl;
            out << "mpoint=" << m.mpoint <<endl;
            out << "user=" << m.user<<endl;
            out << "password=" << m.passwd <<endl;

            file.flush();
            file.close();
        }




}

void DshareWindows::mount_read(){

    QSettings *settings= new QSettings(SMBCONFFILE,QSettings::IniFormat);
    m.passwd = settings->value("Password","").toString();
    m.host = settings->value("host","192.168.1.5").toString();
    m.mpoint = settings->value("mpoint","/home/linutop/windows").toString();
    m.dir = settings->value("dir","shares").toString();
    m.user = settings->value("user","").toString();

    ui->line_dir->setText(m.dir);
    ui->line_host->setText(m.host);
    ui->line_passwd->setText(m.passwd);
    ui->line_mpoint->setText(m.mpoint);
    ui->line_user->setText(m.user);


}


//delete button slot
void DshareWindows::on_pushButton_2_clicked()
{

   Suppr();

}

void DshareWindows::on_pushB_valid_clicked()
{
        mount_save();
        QProcess p;
        p.start("/usr/lib/linutopd/onboot/01smbmounts");
        p.waitForFinished();


}

void DshareWindows::on_pushButton_clicked()
{
    close();
}
