#include "forceresolution.h"
#include "ui_forceresolution.h"
#include "mainwindow.h"

ForceResolution::ForceResolution(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ForceResolution)
{
    ui->setupUi(this);
    disconnect(ui->comboBox,SIGNAL(currentIndexChanged(int)),this,SLOT(on_comboBox_currentIndexChanged(int)));
    QProcess *process = new QProcess();
    process->start("sh", QStringList() << "-c" << "xrandr | grep '*'");
    process->waitForFinished();
    QString tmp = process->readAllStandardOutput();
    oldRes = tmp.split(" ",QString::SkipEmptyParts)[0];
    process->start("sh", QStringList() << "-c" << "xrandr | grep ' connected '");
    process->waitForFinished();
    tmp = process->readAllStandardOutput();
    output = tmp.split(" ",QString::SkipEmptyParts)[0];
    if(oldRes.split("_").size() > 1)
    {
        for(int i=1; i<ui->comboBox->count(); i++)
           if(ui->comboBox->currentText() == oldRes.split("_")[0])
               ui->comboBox->setCurrentIndex(i);
    }
    prevRes = oldRes;
    connect(ui->comboBox,SIGNAL(currentIndexChanged(int)),this,SLOT(on_comboBox_currentIndexChanged(int)));
}

ForceResolution::~ForceResolution()
{
    delete ui;
}

void ForceResolution::on_buttonBox_accepted()
{
    if(ui->comboBox->currentIndex() != 0)
    {
        QFile file("/etc/X11/Xsession.d/45x11-xrandr");
        if(file.open(QIODevice::ReadWrite | QIODevice::Text | QIODevice::Truncate))
        {
            QTextStream out(&file);
            out << cmd1 << endl << cmd2 << endl << cmd3;
            file.flush();
            file.close();
        }
    }
    else
    {
        QFile::remove("/etc/X11/Xsession.d/45x11-xrandr");
    }

}

void ForceResolution::on_comboBox_currentIndexChanged(int index)
{
    if(index != 0)
    {
        QStringList args = ui->comboBox->currentText().split("x");
        QProcess *process = new QProcess();
        process->start("cvt " + args[0] + " " + args[1]);
        process->waitForFinished();
        QString tmp = process->readAllStandardOutput();
        QStringList mode = tmp.split("Modeline");
        mode[1].remove("\n");
        newRes = mode[1].split('"')[1];

        cmd1 = "xrandr --newmode" + mode[1];
        process->start(cmd1);
        process->waitForFinished();

        cmd2 = "xrandr --addmode " + output + " " + newRes;
        process->start(cmd2);
        process->waitForFinished();

        cmd3 = "xrandr --output " + output + " --mode " + newRes;
        process->start(cmd3);
        process->waitForFinished();
    }
    else
    {
        QProcess *process = new QProcess();
        process->start("xrandr --output " + output + " --mode " + oldRes);
        process->waitForFinished();
    }

    sec = 30;
    QTimer *timer = new QTimer();
    connect(timer,SIGNAL(timeout()),this,SLOT(timer_timeout()));
    timer->start(1000);
    message = new QMessageBox();
    message->setWindowIcon(QIcon::fromTheme("video-display"));
    message->setIcon(QMessageBox::Question);
    QPushButton *restoreButton = message->addButton(tr("restore previous configuration"), QMessageBox::AcceptRole);
    QPushButton *keepButton = message->addButton(tr("Keep configuration"),QMessageBox::RejectRole);
    MainWindow a;
    message->setText(a.MsgAlert());
    message->exec();
    timer->stop();
    if (message->clickedButton() == restoreButton) {
        QProcess *process = new QProcess();
        process->start("xrandr --output " + output + " --mode " + oldRes);
        process->waitForFinished();
    } else if (message->clickedButton() == keepButton) {
        prevRes = newRes;
    }

}

void ForceResolution::timer_timeout()
{
    sec -= 1;
    MainWindow a;
    message->setText(a.MsgAlert());
    if(sec == 0)
    {
        message->close();
        QProcess *process = new QProcess();
        process->start("xrandr --output " + output + " --mode " + prevRes);
        process->waitForFinished();
    }
}
