#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QDialog>
#include "ui_mainwindow.h"
#include <QFileSystemWatcher>
#include "ltoplogin.h"
#include <QIcon>

#include <sys/statfs.h>
#include <QPointer>
#include <QtNetwork/QHostAddress>
#include <QtNetwork/QNetworkInterface>
#include <QtNetwork/QTcpSocket>
#define LIBSSH "/sshScript"
#define ROOTFILE "/proc/cmdline"
#define LIBEXECDIR "/usr/lib/ltools"
#include <QRadioButton>
#include "appconfig.h"
#include "vnc.h"
#include <QMessageBox>
#include <QTimer>
#include <QProcess>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
      bool autostartChanged,languageChanged,timeZoneChanged,needReboot,consoleChanged;
      bool kbd_user_defined, tz_user_defined;
      size_t get_mem_totale();
      //size_t get_mem_free();
      char*  readable_fs(double size/*in bytes*/, char *buf);
      QRadioButton *rootOnly;
      QRadioButton *rootOrPiPasswd;
      QRadioButton *rootOrPi;


      QString  get_root();
      QString MsgAlert();

      void getaddressIP();
      void getaddressIPinterface();
      void rebootNeeded();
      void root_device_info();
      void operating_system_info();
      void kernel();
      void architecture();
      void update_locale_settings ();
      QByteArray get_wifi_iface();


public slots:
    void updatePushB_language(QString language,bool cancel);
    void updatePushB_Kbd(QString kbd);
    void updatePushB_tz(QString tz);
    void fileChanged(QString);
    void progress_timeout(int nb, QProcess::ExitStatus st);


private slots:
    void on_pushB_extendMemory_clicked();

    void on_pushB_time_clicked();

    void on_pushB_Help_clicked();

    void on_pushB_Screen_clicked();

    void on_pushB_language_clicked();

    void on_buttonBox_CancelOk_accepted();

    void on_pushB_Web_clicked();

    void on_pushB_kbd_clicked();

    void on_pushB_Login_clicked();

    void on_pushB_Install_clicked();

    void populateInstallTree(QVector<QJsonObject> services);

    void on_list_Install_currentRowChanged(int currentRow);

    void on_pushB_Setup_clicked();

    void on_pushB_Config_clicked();

    void on_pushB_Share_clicked();

    void on_pushB_Windows_clicked();

    void on_pushB_config_clicked();

    void on_pushB_proxy_clicked();

    void on_pushB_lock_clicked();

    void on_pushB_System_clicked();

    void on_chkB_no_hwclock_clicked();

    void on_pushB_Format_clicked();

    void on_checkBox_stateChanged(int arg1);

    void on_pushB_Force_clicked();

    void on_pushB_USB_clicked();

    void set_reboot_sched(bool sched, int hour,  int minute);

    void on_list_Install_doubleClicked(const QModelIndex);

    void on_chkBox_2_clicked();

    void on_lineEdit_email_returnPressed();

    void on_lineEdit_invoice_returnPressed();

    void timer_timeout();

    void on_CHK_disable_blue_clicked();

    void on_CHK_disable_wifi_clicked();

signals:
        void valueSelected(double);


private:
    Ui::MainWindow *ui;
    QFileSystemWatcher *watcher;
    LtopLogin *install;
    vnc *vnc_server;

    AppConfig *config;
    double valHour;
    double valMin;
    void getGetawayAdress();

    void getMacAdress();
    void setRebootSchedule();
    void getRebootSchedule();
    int sec;
    QMessageBox *chk_res_message;
    QProgressDialog *progress_dialog;
    bool blue_wifi_modified;

};

#endif // MAINWINDOW_H
