#include "natproxy.h"


NatProxy::NatProxy(int type, QString host, QString user, QString pwd)
    : QNetworkProxyFactory()
{
    proxyType = type;
    if (proxyType == 1){
        qputenv("http_proxy", "wpad://");
        qputenv("https_proxy", "wpad://");
        qputenv("ftp_proxy", "wpad://");
    }

    pf = px_proxy_factory_new();
    proxyUser = user;
    proxyPwd = pwd;
    proxyUri = QUrl(host);

}

NatProxy::~NatProxy()
{
    px_proxy_factory_free(pf);
}

QList<QNetworkProxy> NatProxy::queryProxy(const QNetworkProxyQuery &query)
{
    QList<QNetworkProxy> l;
    if (proxyType == 2){


       char **proxies = px_proxy_factory_get_proxies(pf, query.url().toString().toUtf8().data());
        for (char **p = proxies; *p; p++){
            if (QString(*p).toLower().startsWith("direct")){
                l << QNetworkProxy(QNetworkProxy::NoProxy);
                break;
            }
            QUrl u(*p);
            int port = u.port();
            if(port == -1)
                port =8080;
            l << QNetworkProxy(QNetworkProxy::HttpProxy,
                               u.host(), port, proxyUser, proxyPwd);
        }

        for (char **p = proxies; *p; p++)
            free(*p);
        free(proxies);
        return l;
    }

    if (proxyType == 2){
        int port = proxyUri.port();
        if (port == -1)
            port = 8080;
        l << QNetworkProxy(QNetworkProxy::HttpProxy,
                           proxyUri.host(), port, proxyUser, proxyPwd);
        return l;

    }

    /*No proxy dectected*/
    l << QNetworkProxy(QNetworkProxy::NoProxy);
    return l;
}
#include <pxProxyFactory.h>
