#ifndef UTILS_H
#define UTILS_H


#include <QProcess>
#include <QObject>
#include <locale>
#include <sys/types.h>
#include <sstream>
#include <string>
#include <fstream>
#include <iostream>
#include <QDebug>
#include <vector>
#include <QVector>
#include <QDir>
#include <QFile>
#include <QPushButton>
#include <QString>
#define REBOOTCMD "shutdown -r now"
#define LOCKFILE "/cdrom/lock.cfg"


using namespace std;

class Utils
{
public:
    Utils();
    static void runCmd(QString command, int timems = 0);
    static string file_get_contents(const char *filename);
    static QString getIconTheme();
};

void get_from_language (const char *locale, string &pkgs, string &kdb, string &tz);
string file_get_contents(const char *filename);
void str_parse(string str, char del, string *ret);
char *get_locale_name(const char *code);
char *get_code_name(const char *name);
void apply_kbd_config(const char *kbd);
inline int _system (const char *cmd);
string get_kbd_name();
void get_autostart_info(QPushButton *btn);
QString get_kbd_name_from_code(QString kbd_code);

struct locale_item {
    const char *code;
    const char *name;
    const char *pkgs;
    const char *tz;
    const char *kbd;
};
extern const struct locale_item locale_data[];

#endif // UTILS_H
