#ifndef VNC_H
#define VNC_H
#ifdef __arm__
#define VNC_CONFFILE "/home/pi/.vnc/passwd"
#define VNC_OPTIONS "/home/pi/.x11vncrc"
#define VNCFILE "/home/pi/.config/autostart/vncserver.desktop"
#else
#define VNC_CONFFILE "/home/linutop/.vnc/passwd"
#define VNC_OPTIONS "/home/linutop/.x11vncrc"
#define VNCFILE "/home/linutop/.config/autostart/vncserver.desktop"
#endif

#include <QCheckBox>
#include <QDialog>
#include "utils.h"
#include <QDir>

namespace Ui {
class vnc;
}

class vnc : public QDialog
{
    Q_OBJECT

public:
    explicit vnc(QWidget *parent = 0);

    void read_startup_file();

    void store_passwd();
    void set_autostart(QCheckBox *chkBox);
    void get_autostart(QCheckBox *chkBox);
    void update_buttons();
    bool vnc_is_running();

    void write_config();
 ~vnc();
private slots:

//button for set a password
    void on_pushB_passwd_clicked();

  //button for starting vnc
    void on_pushB_start_clicked();

    void on_pushB_quit_clicked();

    void on_pushB_restart_clicked();

    void on_pushB_stop_clicked();

    void on_use_passwd_toggled(bool checked);

private:
    Ui::vnc *ui;
};

#endif // VNC_H
