#!/bin/sh

LANG="$1"
ARCHI="$(uname -m)"
CONF_FILE=""

case $ARCHI in
    armv7l)
        CONF_FILE="/etc/default/locale"
    ;;
	x86_64)
		CONF_FILE="/etc/default/locale"
	;;
    i686)
        CONF_FILE="/etc/environment"
    ;;
    *)
        exit 1
    ;;
esac

if grep -q "^LANG=" "$CONF_FILE"
then
    sed -i "s/^LANG=.*/LANG=\"$LANG\"/" "$CONF_FILE"
else
    echo "LANG=\"$1\"" >> "$CONF_FILE"
fi

if [ -e /etc/locale.gen ]
then
    echo "$LANG UTF-8" > /etc/locale.gen
    locale-gen
fi

exit 0

